//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * サーフェーステクスチャヘッダ
 * @author Junpee
 */

#ifndef SURFACE_TEXTURE_H_
#define SURFACE_TEXTURE_H_

#include <Graphics/Texture/Texture.h>

namespace Lamp{

//------------------------------------------------------------------------------
/**
 * サーフェーステクスチャ
 */
class SurfaceTexture : public Texture{
friend class TextureManager;
public:
	/**
	 * サーフェーステクスチャかどうか
	 * @return サーフェーステクスチャならtrue
	 */
	virtual bool isSurfaceTexture() const{ return true; }

	//--------------------------------------------------------------------------
	/**
	 * コピー
	 * @param copyMask コピーマスク
	 * @return コピーされたテクスチャ
	 */
	virtual Texture* copy(u_int copyMask = 0) const{
		return copySurfaceTexture(copyMask);
	}

	/**
	 * サーフェーステクスチャのコピー
	 * @param copyMask コピーマスク
	 * @return コピーされたサーフェーステクスチャ
	 */
	virtual SurfaceTexture* copySurfaceTexture(u_int copyMask = 0) const;

	//--------------------------------------------------------------------------
	// ピクチャインターフェース
	//--------------------------------------------------------------------------
	/**
	 * ピクチャの追加
	 * @param picture 追加するピクチャ
	 */
	virtual void addPicture(Picture* picture){
		Assert(picture_ == NULL);
		Assert(picture != NULL);
		picture_ = picture;
		addPictureReference(picture_);
		stateChanged();
	}

	/**
	 * ピクチャの削除
	 * @param picture 削除するピクチャ
	 */
	virtual void removePicture(Picture* picture){
		Assert(picture_ == picture);
		removePictureReference(picture_);
		picture_ = NULL;
		stateChanged();
	}

	/**
	 * ピクチャ数の取得
	 * @return ピクチャ数
	 */
	virtual int getPictureCount() const{
		if(picture_ == NULL){ return 0; }
		return 1;
	}

	/**
	 * ピクチャの取得
	 * @param index インデックス
	 * @return ピクチャ
	 */
	virtual Picture* getPicture(int index) const{
		Assert(picture_ != NULL);
		Assert(index == 0);
		return picture_;
	}

	//--------------------------------------------------------------------------
	/**
	 * アドレスモードUの設定
	 * @param addressModeU アドレスモードU
	 */
	virtual void setAddressModeU(AddressMode addressModeU){
		addressModeU_ = addressModeU;
		stateChanged();
	}

	/**
	 * アドレスモードUの取得
	 * @return アドレスモードU
	 */
	virtual AddressMode getAddressModeU() const{ return addressModeU_; }

	//--------------------------------------------------------------------------
	/**
	 * アドレスモードVの設定
	 * @param addressModeV アドレスモードV
	 */
	virtual void setAddressModeV(AddressMode addressModeV){
		addressModeV_ = addressModeV;
		stateChanged();
	}

	/**
	 * アドレスモードVの取得
	 * @return アドレスモードV
	 */
	virtual AddressMode getAddressModeV() const{ return addressModeV_; }

	//--------------------------------------------------------------------------
	/**
	 * リピートUVの設定
	 * @param repeatUV リピートUV
	 */
	virtual void setRepeatUV(const TexCoord2& repeatUV){
		repeatUV_ = repeatUV;
		stateChanged();
	}

	/**
	 * リピートUVの取得
	 * @return リピートUV
	 */
	virtual const TexCoord2& getRepeatUV() const{ return repeatUV_; }

	//--------------------------------------------------------------------------
	/**
	 * オフセットUVの設定
	 * @param offsetUV オフセットUV
	 */
	virtual void setOffsetUV(const TexCoord2& offsetUV){
		offsetUV_ = offsetUV;
		stateChanged();
	}

	/**
	 * オフセットUVの取得
	 * @return オフセットUV
	 */
	virtual const TexCoord2& getOffsetUV() const{ return offsetUV_; }

	//--------------------------------------------------------------------------
protected:
	/**
	 * コンストラクタ
	 * @param name 名前
	 * @param scene シーン
	 */
	SurfaceTexture(const String& name, Scene* scene);

	/**
	 * デストラクタ
	 */
	virtual ~SurfaceTexture();

	/**
	 * D3Dテクスチャの取得
	 * @return D3Dテクスチャの取得
	 */
	virtual Direct3DTexture* getD3DTexture();

	//--------------------------------------------------------------------------
private:
	// ピクチャ
	Picture* picture_;
	// アドレスモードU
	AddressMode addressModeU_;
	// アドレスモードV
	AddressMode addressModeV_;
	// リピートUV
	TexCoord2 repeatUV_;
	// オフセットUV
	TexCoord2 offsetUV_;
	// ラップU
	bool wrapU_;
	// ラップV
	bool wrapV_;

};

//------------------------------------------------------------------------------
} // End of namespace Lamp
#endif // End of SURFACE_TEXTURE_H_
//------------------------------------------------------------------------------

